import sys
import commands
import os
import math

#desired function call: python filter.py <fusion.junction> <fusion.out>
#creates fusion_append.out, which has 4 additional columns appended:
# # of blat hits to donor>90    #of blat hits to acceptor>90    #entropy    #distance
# a simple function follows to print junctions to screen where:
# (donor hits>90) = 1 (acceptor hits>90) = 1    entropy > 0     distance > 300,000
#eventually, may be no need to write to a new file. Append new columns to the same fusion.junction file instead

#####################################################################################
def write_out(fusion,blat):
    ''' takes original fusion junction file and blat results from donor and acceptor, appends:
1.) # donor hits > 90
2.) # acceptor hits > 90
3.) # entropy
4.) distance from donor to acceptor'''
    f = open(fusion, "r")
    #n = open("sampfusion.txt", "w")
    b = open(blat, "r")
    out = filePrefix + "_append.out"
    outop = open(out, "w")
    for i in f:
        fusname = i.split("\t")
        if len(fusname) < 3:
            continue;
        dList = []
        aList = []
        dC = 0
        aC = 0
        dist = 0
        for line in b:
            btab = line.split("\t")
            if len(fusname) < 12:
                continue;
            donor = fusname[3] + "donor"
            acceptor = fusname[3] + "acceptor"
            if btab[0] ==donor and int(btab[7]) ==50:
                dList.append(float(btab[11].strip()))       #create list of donor scores
            if btab[0] == acceptor and int(btab[6]) == 1:
                aList.append(float(btab[11].strip()))       #create list of acceptor scores
            #b = open(blat, "r")
        count = 0

        for score in dList:
            percent = score/100*100
            if percent > 90:
                dC +=1                                      #count how many scores > 90 (or whatever threshold)

        for ascore in aList:
            apercent = ascore/100*100
            if apercent > 90:
                aC +=1
        x = fusname[10]
        dist = math.fabs(int(fusname[2])-int(fusname[1]))   #calculate the distance
        L = [str(dC),str(aC), x, str(dist)]
        newline = fusname[:] + L 
        for item in newline:                                #write old columns + new 
            n = item.strip()
            outop.write(n)
            outop.write("\t")
        outop.write("\n")
    outop.close()
    
    return out

##################################################################################
path = os.path.splitext(sys.argv[1])
filePrefix = path[0]

append = write_out(sys.argv[1], sys.argv[2])
